setwd("/home/Erica/2020.8.6/RiboTag")
.libPaths()
.libPaths(c("/home/Erica/R/User2","/usr/lib64/R/library","/usr/share/R/library"))
#清除环境中的变量
rm(list=ls( ))
getwd()

#载入数据，添加列名
options(stringsAsFactors = FALSE)
treat1<-read.table("T1_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","H-R4","umapped"))
treat2<-read.table("T2_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","T-R4","umapped"))
treat3<-read.table("T3_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","K-R4","umapped"))
treat4<-read.table("T4_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Lu-R4","umapped"))
treat5<-read.table("T5_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Li-R4","umapped"))
treat6<-read.table("T6_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","B-R4","umapped"))
control1<-read.table("T7_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","H-R2","umapped"))
control2<-read.table("T8_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","T-R2","umapped"))
control3<-read.table("T9_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","K-R2","umapped"))
control4<-read.table("T10_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Lu-R2","umapped"))
control5<-read.table("T11_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Li-R2","umapped"))
control6<-read.table("T12_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","B-R2","umapped"))

T1 <- treat1[,c(1,3)]
T2 <- treat2[,c(1,3)]
T3 <- treat3[,c(1,3)]
T4 <- treat4[,c(1,3)]
T5 <- treat5[,c(1,3)]
T6 <- treat6[,c(1,3)]
T7 <- control1[,c(1,3)]
T8 <- control2[,c(1,3)]
T9 <- control3[,c(1,3)]
T10 <- control4[,c(1,3)]
T11 <- control5[,c(1,3)]
T12 <- control6[,c(1,3)]

options(stringsAsFactors = FALSE)
treat1<-read.table("T1_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","H-R4","umapped"))
treat2<-read.table("T2_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","T-R4","umapped"))
#treat3<-read.table("T3_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","K-R4","umapped"))
#treat4<-read.table("T4_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Lu-R4","umapped"))
treat5<-read.table("T5_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Li-R4","umapped"))
treat6<-read.table("T6_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","B-R4","umapped"))
control1<-read.table("T7_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","H-R2","umapped"))
control2<-read.table("T8_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","T-R2","umapped"))
#control3<-read.table("T9_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","K-R2","umapped"))
#control4<-read.table("T10_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Lu-R2","umapped"))
control5<-read.table("T11_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","Li-R2","umapped"))
control6<-read.table("T12_R1.fq.clean.sorted.mapq.txt",sep = "\t",col.names = c("gene_id","gene_len","B-R2","umapped"))

T1 <- treat1[,c(1,3)]
T2 <- treat2[,c(1,3)]
#T3 <- treat3[,c(1,3)]
#T4 <- treat4[,c(1,3)]
T5 <- treat5[,c(1,3)]
T6 <- treat6[,c(1,3)]
T7 <- control1[,c(1,3)]
T8 <- control2[,c(1,3)]
#T9 <- control3[,c(1,3)]
#T10 <- control4[,c(1,3)]
T11 <- control5[,c(1,3)]
T12 <- control6[,c(1,3)]

#整合
multimerge<-function(dat=list(),...){
  if(length(dat)<2)return(as.data.frame(dat))
  mergedat<-dat[[1]]
  dat[[1]]<-NULL
  for(i in dat){
    mergedat<-merge(mergedat,i,...)
  }
  return(mergedat)
}



all_counts<- multimerge(list(T6,T12,T1,T7,T5,T11,T2,T8))
all_counts<- all_counts[-1,]

#去掉第一列的gene_id
rownames(all_counts) <- all_counts[,1]
all_counts<-all_counts[,-1]
write.csv(all_counts, "all_mito_counts1.csv")
write.table(all_counts, "all_mito_counts.txt")
all_counts<- read.table(file="all_mito_counts.txt", header = T)

write.csv(all_counts, "cyto_mito_counts.csv")
all_counts<- read.table(file="all_mito_counts.txt", header = T)

#从第二列开始，将每个样本的count循环转化成RPM
i <- 1
repeat{
  mapped_reads<- sum(all_counts[1:22,i])   #408
  #print(mapped_reads)
  RPM <- all_counts[1:22,i]/(10^-6*mapped_reads)
  #print(RPKM)
  all_counts = data.frame(all_counts[1:22,],RPM)
  i <- i+1
  
  if(i>8){
    break
  }
}

#生成表格列名称
count_colname <- read.table("all_mito_counts.txt", header = F,nrow = 1, as.is=TRUE)
RPM_colname <- paste(count_colname[1,],sep="")
colname <- c(count_colname, RPM_colname)
#col_name <- colname[-which(colname=="gene_RPM")] #删除gene_FPKM
names(all_counts) <- colname

#生成all表格
write.csv(all_counts,"ALL_mito_RPM.csv")#row.names是为了去除第一列自动生成的行名，同理col.names=FALSE可以去除第一行自动生成的列名
head(read.csv("ALL_mito_RPM.csv"))

all_counts<- read.csv("ALL_RPM.csv",header = T,row.names=1)


#生成RPM表格
RPM<- all_counts[,13:24]
counts<- all_counts[,1:12]
rownames(counts) <- gsub("Mus_musculus_tRNA-"," ",rownames(counts))
rownames(RPM) <- gsub("Mus_musculus_tRNA-","",rownames(RPM))
write.csv(counts,"counts.csv")
write.csv(RPM, file="RPM.csv")



#----------------
counts<- read.csv("counts.csv",header = T,row.names=1)
RPM<- read.csv("RPM4.csv",header = T,row.names=1)



#生成xlsx文件
#library(xlsx)
#write.xlsx(counts,"counts.xls",row.names = T)

#相关性分析
##过滤reads count >1 小于5
#RPM <- RPM[apply(RPM,1, function(x) sum(x>1) >5,]
##reads count 差距较大，用log以及scale 缩小差距
tRNA_col <- scale(cor(log2(RPM+1)))
##热图
library(pheatmap)
pheatmap(tRNA_col, cluster_cols = F,filename = "tRNA_col.pdf")

RPM<- read.csv("isodecoder8.csv", header = T,row.names=1)

ddCor <- cor(log2(RPM), method = "spearman")
pheatmap(file = "isodecoder_corplot.pdf", ddCor, clustering_method = "average", display_numbers = T)


pheatmap(log2(RPM), cellwidth = 15, cellheight = 12,
         scale = "row",cluster_cols = F, filename="all-tRNA.pdf")

#######
pheatmap(log2(RPM),scale = "row",cluster_cols = F,border_color=NA,show_rownames = F, filename="isodecoder_RPM4.pdf")

#3/17
pheatmap(log2(RPM),scale = "row",cluster_cols = F,border_color=NA,show_rownames = F, filename="isodecoder_RPM_01.pdf")

#####RSIU heatmap
rsiu<- read.csv("iso4_RSIU.csv", header = T,row.names=1)
pheatmap(log2(rsiu),scale = "row",cluster_cols = T,border_color=NA,show_rownames = F, 
         main ="Relative Synonymous Isodecoder Usage (RSIU)" ,filename="isodecoder4_RSIU.pdf")


#Raw heatmaps over all genes
pdf("all_tRNAs.pdf")
heatmap.2(log2(as.matrix(RPM)),col="bluered",scale="column", trace="none", labRow=NA,
          dendrogram="row", margin=c(7, 5),cexCol=0.9,cexRow=0.5,density.info="density",
          ,Colv=F)
dev.off()

#相关性图
library(corrplot)
png('tRNA_cor.png')   #输出到本地
corrplot(cor(log2(RPM)))    #查看表达相似性
dev.off()

#GENE-LEVEL PCA AND REPRODUCIBILITY
#tissue<- c("H.R4","H.R2","T.R4","T.R2","K.R4","K.R2","Lu.R4",
#"Lu.R2","Li.R4","Li.R2","B.R4","B.R2")
tissue<- c("B.R4","B.R2","H.R4","H.R2","Li.R4","Li.R2","T.R4","T.R2")
H <- c("H.R4","H.R2") 
T <- c("T.R4","T.R2") 
#K <- c("K.R4","K.R2") 
#Lu <- c("Lu.R4","Lu.R2") 
Li <- c("Li.R4","Li.R2") 
B <- c("B.R4","B.R2")

#matrix for PCA
mat_data_mouse <- as.matrix(RPM)
log_mat_data_mouse <- log10(mat_data_mouse)
log_mat_data_mouse[!is.finite(log_mat_data_mouse)] <- 0

#MDS plot for mouse tissues
fib_mat_data_mouse <- mat_data_mouse
log_fib_mat_data_mouse <- log10(fib_mat_data_mouse)
log_fib_mat_data_mouse[!is.finite(log_fib_mat_data_mouse)] <- 0
distance.matrix.fib_mouse <- dist(scale(t(fib_mat_data_mouse), center = TRUE, scale = TRUE), method = "euclidean")
mds.fib_mouse <- cmdscale(distance.matrix.fib_mouse, eig = TRUE, x.ret = TRUE)
mds.var.per.fib_mouse <- round(mds.fib_mouse$eig/sum(mds.fib_mouse$eig)*100,1)
mds.values.fib_mouse <- mds.fib_mouse$points
mds.data.fib_mouse <- data.frame(Sample=rownames(mds.values.fib_mouse),
                                 X=mds.values.fib_mouse[,1],
                                 Y=mds.values.fib_mouse[,2])
mds.data.fib_mouse$Type <- c("B","B","H","H","Li","Li","T","T")
mds.data.fib_mouse$Type <- factor(mds.data.fib_mouse$Type, levels =c("B","H","Li","T"))  

#Plot MDS for 6 mouse tissues
plot.mds.fib_mouse <-ggplot(data=mds.data.fib_mouse, aes(x=X, y=Y, label= Sample))+
  geom_text(aes(colour = factor(Type)))+
  theme_bw()+
  xlab(paste("MDS1 - ", mds.var.per.fib_mouse[1], "%", sep=""))+
  ylab(paste("MDS2 - ", mds.var.per.fib_mouse[2], "%", sep = ""))+
  xlim(-20,20)+
  ylim(-12.5,12.5)+
  theme(legend.title=element_blank())
plot.mds.fib_mouse  

#MDS plots
pdf("MDS_plots_isodecoder4.pdf")
plot.mds.fib_mouse    
dev.off()

#Correlation matrix, individual correlation scatter plots between samples
pdf("Corplots_tRNA.pdf")

col3 <- colorRampPalette(c("red", "white", "blue"))
pdf("cor_isodecoder.pdf")
corrplot(cor(log2(RPM)), tl.col = "black",method = "circle", tl.srt = 90,type = "upper",
         addCoef.col = "white",number.cex = .7,title="isodecoders",mar=c(0,0,1,0))
dev.off()

ggplot(as.data.frame(log2(RPM[,H])), aes(x=H.R4, y=H.R2)) + 
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(log2(RPM[,T])), aes(x=T.R4, y=T.R2)) + 
  geom_point() + 
  geom_smooth(method=lm) +
  stat_cor(method = "pearson")
       
ggplot(as.data.frame(log2(RPM[,K])), aes(x=K.R4, y=K.R2)) + 
  geom_point() + 
  geom_smooth(method=lm)+
  stat_cor(method = "pearson")
       
ggplot(as.data.frame(log2(RPM[,Lu])), aes(x=Lu.R4, y=Lu.R2)) + 
  geom_point() + 
  geom_smooth(method=lm)+
  stat_cor(method = "pearson")

ggplot(as.data.frame(log2(RPM[,Li])), aes(x=Li.R4, y=Li.R2)) + 
  geom_point() + 
  geom_smooth(method=lm)+
  stat_cor(method = "pearson")

ggplot(as.data.frame(log2(RPM[,B])), aes(x=B.R4, y=B.R2)) + 
  geom_point() + 
  geom_smooth(method=lm)+
  stat_cor(method = "pearson")
dev.off()


#1、DESeq找差异基因
library(tidyverse)
library(DESeq2)
#DESEQ2 DIFFERENTIAL ANALYSIS
countData <- counts
colData <- data.frame(row.names=colnames(countData),condition=
                        factor(c("H","H","T","T","K","K","Lu","Lu","Li","Li","B","B"),levels =c("H","T","K","Lu","Li","B")))

dds <- DESeqDataSetFromMatrix(countData = countData,
                              colData = colData,
                              design= ~ condition)
#do likelihood ratio test so that Padj represents change across all samples
dds <- DESeq(dds,test="LRT", reduced=~1)
res <- results(dds)
#先排序，按 padj 值升序排序，相同 padj 值下继续按 log2FC 降序排序
res <- res[order(res$padj, res$log2FoldChange, decreasing = c(FALSE, TRUE)), ]
#标记上调和下调
res[which(res$log2FoldChange >= 1 & res$padj < 0.01),'sig'] <- 'up'
res[which(res$log2FoldChange <= -1 & res$padj < 0.01),'sig'] <- 'down'
res[which(abs(res$log2FoldChange) <= 1 | res$padj >= 0.01),'sig'] <- 'none'
#输出选择的差异基因总表
res_select <- subset(res, sig %in% c('up', 'down'))
write.table(res_select, file = 'DE.select_tRNA.txt', sep = '\t', col.names = NA, quote = FALSE)
write.csv(res,file="DE.all_tRNA.csv")

diff <- merge(as.data.frame(res),RPM,by="row.names")
diff <- diff[,c(1,7,8:ncol(diff))]
write.csv(diff,"tRNA_diff.csv")

##根据 up 和 down 分开输出
res1_up <- subset(res1, sig == 'up')
res1_down <- subset(res1, sig == 'down')
write.table(res1_up, file = 'control_treat.DESeq2.up.txt', sep = '\t', col.names = NA, quote = FALSE)
write.table(res1_down, file = 'control_treat.DESeq2.down.txt', sep = '\t', col.names = NA, quote = FALSE)

diff <- RPM[(rownames(RPM) %in% rownames(res[res$padj<.001,])),]
diff <- diff[,tissue]
diff <- diff / rowMeans(diff[,1:2])     #比上1、2列？？

#差异热图  ??
pdf("diff_tRNA_heatmaps.pdf")
heatmap.2(log2(as.matrix(diff)),col="bluered",scale="none", trace="none",
          dendrogram="none", margin=c(7, 5),cexCol=0.9,cexRow=0.3,density.info="density",
          ,Colv=F, key = T,key.title=NA,
          key.xlab="Log2 Fold-Change",key.ylab = "Density",
          main="Differential tRNA Gene Expression \n Padj < 0.001 \n Tissue Only",keysize=0.35, 
          key.par = list(cex=0.5))
dev.off()


##ggplot2 差异火山图
library(ggplot2)
#默认情况下，横轴展示 log2FoldChange，纵轴展示 -log10 转化后的 padj
png("de_iso_volcano.png")
ggplot(data = res, aes(x = log2FoldChange, y = -log10(padj), color = sig)) +
  geom_point(size = 1) + #绘制散点图
  scale_color_manual(values = c('red', 'gray', 'green'), limits = c('up', 'none', 'down')) + #自定义点的颜色
  labs(x = 'log2 Fold Change', y = '-log10 adjust p-value', title = 'control vs treat', color = '') + #坐标轴标题
  theme(plot.title = element_text(hjust = 0.5, size = 14), panel.grid = element_blank(), #背景色、网格线、图例等主题修改
        panel.background = element_rect(color = 'black', fill = 'transparent'),
        legend.key = element_rect(fill = 'transparent')) +
  geom_vline(xintercept = c(-1, 1), lty = 3, color = 'black') + #添加阈值线
  geom_hline(yintercept = 2, lty = 3, color = 'black') +
  xlim(-12, 12) + ylim(0, 35) #定义刻度边界
dev.off()


"H-T","H-K","H-Lu","H-Li","H-B","T-K",
"T-Lu","T-Li","T-B","K-Lu","K-Li","K-B",
"Lu-Li","Lu-B","Li-B"

###DESeq 两两比较
###1、DESeq找差异基因
library(tidyverse)
library(DESeq2)
##要求对象必须是矩阵
counts<-as.matrix(counts)
exp_H_T =counts[,c(9,10,11,12)]        ###
exp_H_T[1,]
condition <- factor(c(rep("Li",2),rep("B",2)), levels = c("Li","B"))  ###
#colData也可以自己在excel做好另存为.csv格式，再导入即可
colData <- data.frame(row.names=colnames(exp_H_T), condition)
#2构建dds对象,开始DESeq流程
dds <- DESeqDataSetFromMatrix(exp_H_T, colData, design= ~ condition)
dds <- DESeq(dds)
# 查看一下dds的内容
dds

#3 总体结果查看
res = results(dds, contrast=c("condition", "Li", "B"))   ###
res = res[order(res$pvalue),]       
summary(res)
#所有结果先进行输出
write.csv(res,file="res_iso_Li_B.csv")   ###

#4 提取差异表达genes（DEGs）
#先排序，按 padj 值升序排序，相同 padj 值下继续按 log2FC 降序排序
res <- res[order(res$padj, res$log2FoldChange, decreasing = c(FALSE, TRUE)), ]
#标记上调和下调
res[which(res$log2FoldChange >= 1 & res$padj < 0.01),'sig'] <- 'up'
res[which(res$log2FoldChange <= -1 & res$padj < 0.01),'sig'] <- 'down'
res[which(abs(res$log2FoldChange) <= 1 | res$padj >= 0.01),'sig'] <- 'none'
#输出选择的差异基因总表
res_select <- subset(res,sig %in% c('up', 'down'))
write.csv(res_select, file = 'select_iso_Li_B.csv')   ###


#bar chart
data<- counts
#mean
mean_H<- mean(unlist(as.list(data[,c(1:2)])))
mean_T<- mean(unlist(as.list(data[,c(3:4)])))
mean_K<- mean(unlist(as.list(data[,c(5:6)])))
mean_Lu<- mean(unlist(as.list(data[,c(7:8)])))
mean_Li<- mean(unlist(as.list(data[,c(9:10)])))
mean_B<- mean(unlist(as.list(data[,c(11:12)])))
#标准误
library("plotrix")
SE_H<- std.error(unlist(as.list(data[,c(1:2)])))
SE_T<- std.error(unlist(as.list(data[,c(3:4)])))
SE_K<- std.error(unlist(as.list(data[,c(5:6)])))
SE_Lu<- std.error(unlist(as.list(data[,c(7:8)])))
SE_Li<- std.error(unlist(as.list(data[,c(9:10)])))
SE_B<- std.error(unlist(as.list(data[,c(11:12)])))

#画分布图
png("mean_tRNA.png")
density<-c(mean_H,mean_T,mean_K,mean_Lu,mean_Li,mean_B)
snp_name<-c("H","T","K","Lu","Li","B")
barCenters<-barplot(beside=T,density,snp_name,border="black",col=c("purple","green","blue"),
                    width=c(2,2,2,2,2),space=c(0.5,0.5,0.5,0.5,0.5,0.5))
#beside:逻辑参数。如果FALSE，那么将绘画堆叠式的条形；如果是TRUE，将绘画并列式条形。space:表示
#棒状图直接的距离，ylim：表示Y轴的取值范围
d<-data.frame(snp_name<-c("H","T","K","Lu","Li","B"),SE<-c(SE_H,SE_T,SE_K,SE_Lu,SE_Li,SE_B),mean<-c(mean_H,mean_T,mean_K,mean_Lu,mean_Li,mean_B))
#创建一个基因型平均值及标准误的数据框
title(ylab="Mean Counts",main="Mean tRNA counts by tissue(n=2)",cex.lab=1.5,cex.main = 2.0, font.main= 2)
#cex.lab坐标轴字体大小
arrows(barCenters,d$mean-d$SE*2,barCenters,d$mean+d$SE*2, length=0.05, angle=90, code=3)
#用arrows函数画误差棒
dev.off()


#合并多个DE文件的第一列
setwd("/home/Erica/2020.8.6/RiboTag/2020-7-13 Tissue tRNA-seq/PM-XS01KF2020060036-02-中大附一12个外来文库包1条lane测序不过滤任务单/ANNO_XS01KF2020060036_PM-XS01KF2020060036-02_BH7KNGCCX2_2020-07-11/Rawdata/cleanR1/de_iso/select")
##批量读取文件下的文件，形成文件名开头的变量
mycsvfile = list.files(pattern="*.csv")
list2env(
  lapply(setNames(mycsvfile, make.names(gsub("*.csv$", "", mycsvfile))),
         read.csv), envir = .GlobalEnv)

#去除csv的文件名称以便后来获取函数名
files<-unlist(lapply(mycsvfile, FUN = function(x) {return(strsplit(x, split = ".csv")[[1]][1])}))

all_iso_de <- matrix(unlist(list(select_iso_H_B[,1], select_iso_H_K[,1], select_iso_H_Li[,1], select_iso_H_Lu[,1], select_iso_H_T[,1], select_iso_K_B[,1], select_iso_K_Li[,1], 
                              select_iso_K_Lu[,1], select_iso_Li_B[,1], select_iso_Lu_B[,1], select_iso_Lu_Li[,1], select_iso_T_B[,1], select_iso_T_K[,1], select_iso_T_Li[,1],  
                              select_iso_T_Lu[,1])))
#去除重复
all_iso_de<- all_iso_de[!duplicated(all_iso_de[,1]),]
write.csv(all_iso_de, file = 'all_iso_de.csv')
#根据all_iso_de取RPM
de_RPM <- RPM[all_iso_de,]
write.csv(de_RPM, file = 'de_RPM.csv')

#heatmaps over de RPM
pdf("de_RPM.pdf")
heatmap.2(log2(as.matrix(de_RPM)),col="bluered",scale="column", trace="none", labRow=NA,
          dendrogram="row", margin=c(7, 5),cexCol=0.9,cexRow=0.5,density.info="density",
          ,Colv=F)
dev.off()


##########
pheatmap(log2(de_RPM),scale = "row",cluster_cols = F,border_color=NA,fontsize_row=3, filename="de_RPM2.pdf")


#bk=unique(c(seq(5,15, length=100)))
pheatmap(log2(de_RPM), scale = "row",clustering_method = "average" ,
         clustering_distance_rows = "correlation",cellwidth = 10, cellheight = 8,
         color = colorRampPalette(c("navy", "white", "firebrick3"))(100),filename="de_RPM3.pdf")


















#DESeq2软件独有的normlization方法
rld <- rlogTransformation(dds2)  ## 得到经过DESeq2软件normlization的表达矩阵
exprSet_new=assay(rld)
par(cex = 0.7)
n.sample=ncol(exp_H_T)
if(n.sample>40) par(cex = 0.5)
cols <- rainbow(n.sample*1.2)
par(mfrow=c(2,2))
pdf("plot.pdf")
boxplot(exp_H_T, col = cols,main="expression value",las=2)
boxplot(exprSet_new, col = cols,main="expression value",las=2)
hist(exp_H_T)
hist(exprSet_new)
dev.off()


#limma
library(limma)
RPM
#gene_list
group <- factor(c(rep("H",2),rep("T",2),rep("K",2),rep("Lu",2),rep("Li",2),rep("B",2)))
#也可以自己在excel做好另存为.csv格式，再导入即可
gene_list <- data.frame(row.names=colnames(RPM), group)
gene_list
#加载limma包，构造如下矩阵
suppressMessages(library(limma))
design <- model.matrix(~0+factor(group))
colnames(design)=levels(factor(group))
rownames(design)=colnames(RPM)
design

#多组比较
contrast.matrix<-makeContrasts("H-T","H-K","H-Lu","H-Li","H-B","T-K",
                               "T-Lu","T-Li","T-B","K-Lu","K-Li","K-B",
                               "Lu-Li","Lu-B","Li-B",levels=design)
contrast.matrix

##step1
fit <- lmFit(RPM,design)
##step2
fit2 <- contrasts.fit(fit, contrast.matrix)
fit2 <- eBayes(fit2)  
##step3
tempOutput = topTableF(fit2,adjust="BH",sort.by="F",, n=Inf)
#tempOutput = subset(tempOutput, select=c("adj.P.Val","P.Value","logFC"))
nrDEG = na.omit(tempOutput) 
nrDEG
write.csv(nrDEG, "limma_trna.csv")



##用dplyr包计算数据
df<- read.csv("counts.csv", header = T)
colnames(df)[1:6] <- c("H","T","K","Lu","Li","B")
str(df)# 显示数据集内容
group <- factor(c(rep("H",2),rep("T",2),rep("K",2),rep("Lu",2),rep("Li",2),rep("B",2)))
tissue <- factor(c("H","T","K","Lu","Li","B"))

# 获取三个组各个基因表达量的平均值和标准差
library(tidyr)
library(dplyr)
df_stat <- tbl_df(df) %>%
  gather(tissue, value, -group) %>%  # 将"宽数据"转化为"长数据"
  group_by(group, tissue) %>%         # 将数据分组
  summarise(mean=mean(value, na.rm=T), sd=sd(value, na.rm=T)) %>% # 计算每组数据的mean和sd
  ungroup()
str(df_stat)

# 画图
#直接在画图的语句中计算出error_bar所需的数据：
#（即下面的ymin=mean-sd和ymax=mean+sd语句）。
library(ggplot2)
dodge <- position_dodge(width=.9)
df_stat %>% ggplot() +
  geom_bar(aes(x=gene, y=mean, fill=Group), 
           stat="identity", position=dodge) +
  geom_errorbar(aes(x=gene, ymin=mean-sd, ymax=mean+sd, color=Group), 
                stat="identity", position=dodge, width=.3)


#合并多个DE文件的第一列
setwd("/home/Erica/2020.8.6/RiboTag/2020-7-13 Tissue tRNA-seq/PM-XS01KF2020060036-02-中大附一12个外来文库包1条lane测序不过滤任务单/ANNO_XS01KF2020060036_PM-XS01KF2020060036-02_BH7KNGCCX2_2020-07-11/Rawdata/clean/DESeq/select")
##批量读取文件下的文件，形成文件名开头的变量
mycsvfile = list.files(pattern="*.csv")
list2env(
  lapply(setNames(mycsvfile, make.names(gsub("*.csv$", "", mycsvfile))),
         read.csv), envir = .GlobalEnv)


#去除csv的文件名称以便后来获取函数名
files<-unlist(lapply(mycsvfile, FUN = function(x) {return(strsplit(x, split = ".csv")[[1]][1])}))

##建立第一个matrix矩阵
de_data<-as.matrix(get(files[1])[,1])
rownames(data)<-row.names(get(files[1]))
colnames(data)<-files[1]

##循环合并一下
for (i in files[-1]){
  tmp<-as.matrix(get(i)[,1])
  rownames(tmp)<-row.names(get(i))
  colnames(tmp)<-i
  de_data<-rbind(de_data,tmp)
}

#去除重复数据
duplicated(de_data)
de_data2<- filter(de_data, !duplicated(de_data[,1]))


####输出文件
write.csv(de_data,"merge_de.csv")

#简单的批量读入
path <- "/home/Erica/2020.8.6/RiboTag/2020-7-13 Tissue tRNA-seq/PM-XS01KF2020060036-02-中大附一12个外来文库包1条lane测序不过滤任务单/ANNO_XS01KF2020060036_PM-XS01KF2020060036-02_BH7KNGCCX2_2020-07-11/Rawdata/clean/DESeq/select"
fileNames <- dir(path) 
filePath <- sapply(fileNames, function(x){paste(path,x,sep='/')}) 
DE_select_data <- lapply(filePath, function(x){read.csv(x, header=F)})  

n=length(fileNames)
for (i in 1:n){
  new.data = read.csv(file = filePath[i], header=F)
}

