#TE top 1%, 100
#TE 去掉cv后5% 看差异
TE_cv<- read.csv(file="TE_cv_0.05.csv", header = T,row.names = 1)
TE_fpkm<- read.csv("TE_4_fpkm_cv_0.05.csv",header = T )
codon <- read.csv("mm10.codon.stat.csv")

##随机选取1%的gene做对照
genename<- read.csv(file="gene_name.csv")
gene_name<- genename[,-1]
colnames(gene_name)<- c("X","Gene.Name")
fpkm<- read.csv("fpkm_input_4.csv",header = T)
fpkm<- merge(fpkm,gene_name,by="X")
codon <- read.csv("mm10.codon.stat.csv")

set.seed(1234)
fpkm1<- fpkm %>% sample_n(57, replace = FALSE)
set.seed(1)
fpkm2<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(2)
fpkm3<- fpkm %>% sample_n(57, replace = FALSE)  
set.seed(3)
fpkm4<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(4)
fpkm5<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(5)
fpkm6<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(6)
fpkm6<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(777)
fpkm7<- fpkm %>% sample_n(57, replace = FALSE)  


#brain
B<- TE_fpkm[TE_fpkm[,3]> quantile(TE_fpkm[,3], probs=0.99), c(1,2,7,8)]      #
codon_B <- merge(B, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:48,i]*(codon_B[1:48,4]+codon_B[1:48,3])  # 3 4 
  codon_B = data.frame(codon_B[1:48,],number)
  sum_num= sum(codon_B[1:48,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}

#HEART
H<-TE_fpkm[TE_fpkm[,4]> quantile(TE_fpkm[,4], probs=0.99), c(1,2,9,10)]
codon_B <- merge(H, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:49,i]*(codon_B[1:49,3]+codon_B[1:49,4])
  codon_B = data.frame(codon_B[1:49,],number)
  sum_num= sum(codon_B[1:49,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}

#LIVER
L<-TE_fpkm[TE_fpkm[,4]> quantile(TE_fpkm[,4], probs=0.99), c(1,2,11)]  #6 7
codon_B <- merge(L, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 6
repeat{
  number <- codon_B[1:49,i]*codon_B[1:49,3]
  codon_B = data.frame(codon_B[1:49,],number)
  sum_num= sum(codon_B[1:49,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>66){
    print(sum_num)
    break
  }
}

#TESTIS
T<-TE_fpkm[TE_fpkm[,6]> quantile(TE_fpkm[,6], probs=0.99), c(1,2,12,13)]
codon_B <- merge(T, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:48,i]*(codon_B[1:48,4]+codon_B[1:48,3])
  codon_B = data.frame(codon_B[1:48,],number)
  sum_num= sum(codon_B[1:48,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}



###codon index的热图
codon<- read.csv(file="codon_percent_te0.01.csv", header = T,row.names = 1)
codon<- codon[,-1]
c<- t(data.frame(codon))
library(pheatmap)
pheatmap(log2(c),scale = "column", las=2,cluster_cols = T,cluster_rows = F,border_color=NA,
         fontsize_row=20,cellwidth = 20,main ="Codon index",filename="codon_index_0.01.pdf")


#RSCU RSAU 相关性图
t_r<- read.csv("RSCU0.01_RSAU.csv", header = T)

library(ggplot2)
library(gridExtra)
library(cowplot)
library(ggpubr)

url<- "https://cran.r-project.org/src/contrib/Archive/ggpubr/ggpubr_0.1.6.tar.gz"
install.packages(url, repos=NULL, type="source")

install.packages('ggpubr', repos='https://cran.r-project.org/src/contrib/Archive/ggpubr/ggpubr_0.1.2.tar.gz')

pdf("RSCU0.01_RSAU.pdf")     #index值

ggplot(as.data.frame(t_r[,c(2,6)]), aes(y=log2(t_r[,2]), x=log2(t_r[,6]))) + 
  ylab("RSCU of Brain")+ xlab("RSAU of Brain")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(3,7)]), aes(y=log2(t_r[,3]),x=log2(t_r[,7]))) + 
  ylab("RSCU of Heart")+ xlab("RSAU of Heart")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(4,8)]), aes(y=log2(t_r[,4]),x=log2(t_r[,8]))) + 
  ylab("RSCU of Liver")+ xlab("RSAU of Liver)")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(5,9)]),aes(y=log2(t_r[,5]), x=log2(t_r[,9]))) + 
  ylab("RSCU of Testis")+ xlab("RSAU of Testis")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

dev.off()

#codon index anticodon index值
fc<- read.csv("codon_anti_index.csv", header = T)
t_r<- fc[,-1]    ##ribo数据在前

pdf("fc_codon_anti_index.pdf")     #index值

ggplot(as.data.frame(t_r[,c(2,6)]), aes(y=log2(t_r[,2]), x=log2(t_r[,6]))) + 
  ylab("RSCU of Brain")+ xlab("RSAU of Brain")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(3,7)]), aes(y=log2(t_r[,3]),x=log2(t_r[,7]))) + 
  ylab("RSCU of Heart")+ xlab("RSAU of Heart")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(4,8)]), aes(y=log2(t_r[,4]),x=log2(t_r[,8]))) + 
  ylab("RSCU of Liver")+ xlab("RSAU of Liver)")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

ggplot(as.data.frame(t_r[,c(5,9)]),aes(y=log2(t_r[,5]), x=log2(t_r[,9]))) + 
  ylab("RSCU of Testis")+ xlab("RSAU of Testis")+
  geom_point() + 
  geom_smooth(method=lm) + 
  stat_cor(method = "pearson")

dev.off()



##随机选取1%的gene做对照
genename<- read.csv(file="gene_name.csv")
gene_name<- genename[,-1]
colnames(gene_name)<- c("X","Gene.Name")
fpkm<- read.csv("fpkm_input_4.csv",header = T)
fpkm<- merge(fpkm,gene_name,by="X")
codon <- read.csv("mm10.codon.stat.csv")

set.seed(1234)
fpkm1<- fpkm %>% sample_n(57, replace = FALSE)
set.seed(1)
fpkm2<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(2)
fpkm3<- fpkm %>% sample_n(57, replace = FALSE)  
set.seed(3)
fpkm4<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(4)
fpkm5<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(5)
fpkm6<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(6)
fpkm6<- fpkm %>% sample_n(57, replace = FALSE)  ##
set.seed(777)
fpkm7<- fpkm %>% sample_n(57, replace = FALSE)  


#brain
B<- fpkm7[,c(1,6,2)]
codon_B <- merge(B, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]


#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:251,i]*codon_B[1:251,4]  # 3 4 
  codon_B = data.frame(codon_B[1:251,],number)
  sum_num= sum(codon_B[1:251,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}


#HEART
H<- fpkm7[,c(1,6,3)]
codon_B <- merge(H, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]
#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:257,i]*codon_B[1:257,4]
  codon_B = data.frame(codon_B[1:257,],number)
  sum_num= sum(codon_B[1:257,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}

#LIVER
L<- fpkm7[,c(1,6,4)]
codon_B <- merge(L, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 6
repeat{
  number <- codon_B[1:255,i]*codon_B[1:255,3]
  codon_B = data.frame(codon_B[1:255,],number)
  sum_num= sum(codon_B[1:255,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>66){
    print(sum_num)
    break
  }
}


#TESTIS
T<- fpkm7[,c(1,6,5)]
codon_B <- merge(T, codon, by="Gene.Name", all.x=TRUE)
codon_B <- codon_B[complete.cases(codon_B),]

#计算每个codon的值 codon基因中的占比X这个基因fpkm，把全部基因的加起来
i <- 7
repeat{
  number <- codon_B[1:263,i]*codon_B[1:263,4]
  codon_B = data.frame(codon_B[1:263,],number)
  sum_num= sum(codon_B[1:263,i+61])
  print(sum_num)
  i <- i+1
  
  if(i>67){
    print(sum_num)
    break
  }
}


