for x in *clean25.fq.gz
do
	(bowtie2 --min-score G,1,8 --local -D 20 -R 3 -N 1 -L 10 -i S,1,0.5 -p 3 -x /home/Erica/genome/new_mm10_cyto_mito -U ${x} |samtools sort -O bam -@ 6 -o ${x%%.fq.gz}.sorted.bam)
	samtools view -q 10 ${x%%.fq.gz}.sorted.bam -b -o ${x%%.fq.gz}.sorted.mapq.bam
	samtools index ${x%%.fq.gz}.sorted.mapq.bam
	samtools idxstats ${x%%.fq.gz}.sorted.mapq.bam > ${x%%.fq.gz}.sorted.mapq.txt
done

